import React, { Component, Fragment } from "react";
import { bindActionCreators } from "redux";
import { connect } from "react-redux";

import * as actions from "../actions/todo";
import List from "../components/list";
import LoadForm from "../components/loadForm";

class App extends Component {
	state = {
		openAddForm: false
	};

	openFormHandler = () => this.setState(prevState => ({ openAddForm: !prevState.openAddForm }));

	render() {
		const { list } = this.props;
		const { openAddForm } = this.state;
		return (
			<Fragment>
				<h1 className="h1-tag">
					Доставка грузов "to-do list" -{" "}
					<span onClick={this.openFormHandler} className="h1-tag h1-tag--add">
						Добавить груз
					</span>
				</h1>
				<div className="todo">
					<List list={list} />

					{openAddForm && <LoadForm />}
				</div>
			</Fragment>
		);
	}
}

const mapStateToProps = state => ({
	list: state.todo.list
});

const mapDispatchToProps = dispatch => bindActionCreators({ ...actions }, dispatch);

export default connect(
	mapStateToProps,
	mapDispatchToProps
)(App);
